︠f1154537-dbcd-4215-a44c-8a6a1d039dd8i︠
%md

**Problem 2:**

Write a function that takes as input a positive integer $n$ and outputs the first $n$ levels of the
cyclotomic $\ZZ_3$-extension of $\QQ$ as a tower of relative extensions (so each field has
degree 3 over the one below it).   The code should 'work' in general, though
of course it will likely be very, very slow as $n$ gets bigger.    How big of $n$ can you
give as input before this starts taking a long time or getting slow?

Figuring out what I mean by "the cyclotomic $\ZZ_3$ extension of $\QQ$" is part of this problem.
If you don't know, start by asking any student of Ralph Greenberg.
︡733f67ec-5e54-45ac-9c22-56d23c821173︡︡{"done":true,"md":"\n**Problem 2:**\n\nWrite a function that takes as input a positive integer $n$ and outputs the first $n$ levels of the\ncyclotomic $\\ZZ_3$-extension of $\\QQ$ as a tower of relative extensions (so each field has\ndegree 3 over the one below it).   The code should 'work' in general, though\nof course it will likely be very, very slow as $n$ gets bigger.    How big of $n$ can you\ngive as input before this starts taking a long time or getting slow?\n\nFiguring out what I mean by \"the cyclotomic $\\ZZ_3$ extension of $\\QQ$\" is part of this problem.\nIf you don't know, start by asking any student of Ralph Greenberg."}
︠26addea1-2648-4956-bcaa-fc6e32dde18ai︠
%md
Let $K$ be the cyclotomic field of order $3^{n+1}$ and write $Gal(K/\QQ) =\langle \tau \rangle \times \langle \sigma \rangle\cong \ZZ/(2) \times \ZZ/(3^n)=$. Let $z$ be a primitive $3^{n+1}$th root of unity and $y_k=z^{3^k}+\overline{z^{3^k}}$ for $0\leq k \leq n$. Then $y_k$ is invariant under $\tau$ for all $k$ and $y_k$ is invariant under $\sigma^{3^j}$ if and only if $j\geq n-k$ (take the $j$ mod $3^n$). Hence, the fixed field of $\langle \tau \rangle \times \langle \sigma^{3^k} \rangle$ is $\QQ(y_{n-k})$. The code below will successfully adjoin the $y_k$'s using the fact (which can be proved via induction) that $\pm y_k$ solves $x^3-3x+y_{k+1}=0$.
︡f6ee4862-3c99-4429-b990-61129de33c53︡︡{"done":true,"md":"Let $K$ be the cyclotomic field of order $3^{n+1}$ and write $Gal(K/\\QQ) =\\langle \\tau \\rangle \\times \\langle \\sigma \\rangle\\cong \\ZZ/(2) \\times \\ZZ/(3^n)=$. Let $z$ be a primitive $3^{n+1}$th root of unity and $y_k=z^{3^k}+\\overline{z^{3^k}}$ for $0\\leq k \\leq n$. Then $y_k$ is invariant under $\\tau$ for all $k$ and $y_k$ is invariant under $\\sigma^{3^j}$ if and only if $j\\geq n-k$ (take the $j$ mod $3^n$). Hence, the fixed field of $\\langle \\tau \\rangle \\times \\langle \\sigma^{3^k} \\rangle$ is $\\QQ(y_{n-k})$. The code below will successfully adjoin the $y_k$'s using the fact (which can be proved via induction) that $\\pm y_k$ solves $x^3-3x+y_{k+1}=0$."}
︠04baae25-26fd-496e-b36d-3d2f17e7dc91s︠

def threecyclotomic(n):
    K.<z> = CyclotomicField(3^(n+1))
    Ks = [QQ]
    R = QQ['t0']
    Rs = [R]
    for j in [1..n]:
        newField = Ks[-1].extension((Rs[-1].0)^3 - 3*(Rs[-1].0) +
                Ks[-1].0,'a%s'%j)
        Ks.append(newField)
        Rs.append(newField['t%s'%j])

    return Ks
︡54cc41f6-d8d8-48ae-80ce-12aedb46969f︡︡{"done":true}
︠edbb8939-265f-48d3-9397-0b0a7a99dfeb︠
%time threecyclotomic(5)
︡b7ec80b2-7726-41df-a858-20810ca77005︡︡{"stdout":"[Rational Field, Number Field in a1 with defining polynomial t0^3 - 3*t0 + 1, Number Field in a2 with defining polynomial t1^3 - 3*t1 + a1 over its base field, Number Field in a3 with defining polynomial t2^3 - 3*t2 + a2 over its base field, Number Field in a4 with defining polynomial t3^3 - 3*t3 + a3 over its base field, Number Field in a5 with defining polynomial t4^3 - 3*t4 + a4 over its base field]","done":false}︡{"stdout":"\n","done":false}︡{"stdout":"CPU time: 1.06 s, Wall time: 1.12 s\n","done":false}︡{"done":true}
︠fa93cf36-a423-4765-b3d8-0ac6c00f78d7︠
%time threecyclotomic(7)
︡9b351206-309b-4266-a013-3a7828e169c9︡︡{"stdout":"[Rational Field, Number Field in a1 with defining polynomial t0^3 - 3*t0 + 1, Number Field in a2 with defining polynomial t1^3 - 3*t1 + a1 over its base field, Number Field in a3 with defining polynomial t2^3 - 3*t2 + a2 over its base field, Number Field in a4 with defining polynomial t3^3 - 3*t3 + a3 over its base field, Number Field in a5 with defining polynomial t4^3 - 3*t4 + a4 over its base field, Number Field in a6 with defining polynomial t5^3 - 3*t5 + a5 over its base field, Number Field in a7 with defining polynomial t6^3 - 3*t6 + a6 over its base field]","done":false}︡{"stdout":"\n","done":false}︡{"stdout":"CPU time: 75.71 s, Wall time: 78.90 s\n","done":false}︡{"done":true}
︠143dbc44-fb7a-48ed-bed3-e8fec27f79ces︠
%time K = threecyclotomic(2)
︡fe35322a-8a2c-485d-b33f-1a6b2c6717c1︡︡{"stdout":"CPU time: 0.04 s, Wall time: 0.09 s\n","done":false}︡{"done":true}
︠cd1b7697-e376-48d7-b547-2faed393a373s︠
K
︡a3184c5b-f82a-48f8-a221-8a05e627c1b4︡︡{"stdout":"[Rational Field, Number Field in a1 with defining polynomial t0^3 - 3*t0 + 1, Number Field in a2 with defining polynomial t1^3 - 3*t1 + a1 over its base field]\n","done":false}︡{"done":true}
︠3099fa5e-4a90-4b8d-90e3-6d0a50ff8196s︠
K[-1].absolute_field('a').defining_polynomial().galois_group()
︡92589fff-18c9-45cd-b01c-a3f21d477ade︡︡{"stdout":"Transitive group number 1 of degree 9","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠da3d17a6-a57f-4bca-8a99-bd44ea829445s︠
K[-1].absolute_field('a').discriminant().factor()
︡8c85934c-4169-4b1d-b3ef-9e3e3fac4ee9︡︡{"stdout":"3^22\n","done":false}︡{"done":true}
︠306d5ceb-601f-4082-b5ce-281ede11b975︠









